#property copyright "Copyright  2012 by MandySoft"
#property link      "http://www.2p.cz/en/forex_metatrader"
// Version: 0.1
/* Revision:
  v0.1
    - initial version
  v0.2
    - weekdays support
*/

#include <MarketDef.mqh>
#include <MarketHelper.mqh>
#include <TradingHours.mqh>

#define NUM_BUFFERS 5

#property indicator_separate_window
//#property indicator_chart_window
#property indicator_buffers NUM_BUFFERS
#property indicator_color1 LightGreen   // NY
#property indicator_color2 Blue   // London
#property indicator_color3 Yellow // Tokyo
#property indicator_color4 Coral  // Sydney
#property indicator_color5 Gold  // NY 7-9
#property indicator_minimum 0.8
#property indicator_maximum 5.2 //NUM_BUFFERS+1

int buffer2market[NUM_BUFFERS];
//color bufferColor[NUM_BUFFERS] = {Lime, Blue, Red, Yellow, Green};

double buff0[];
double buff1[];
double buff2[];
double buff3[];
double buff4[];
double buff5[];
double buff6[];
double buff7[];

#define LINE_WIDTH 3
#define BUFF_TRUE 1

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init() {
   int i;
   buffer2market[TRADING_HOURS_NEWYORK] = MARKET_NEWYORK;
   buffer2market[TRADING_HOURS_LONDON] = MARKET_LONDON; 
   buffer2market[TRADING_HOURS_TOKYO] = MARKET_TOKYO;
   buffer2market[TRADING_HOURS_SYDNEY] = MARKET_SYDNEY;
   buffer2market[TRADING_HOURS_NEWYORK_07_09] = MARKET_NEWYORK_07_09;
   IndicatorBuffers(NUM_BUFFERS);
   SetIndexBuffer(0, buff0);
   SetIndexBuffer(1, buff1);
   SetIndexBuffer(2, buff2);
   SetIndexBuffer(3, buff3);
   SetIndexBuffer(4, buff4);
//   SetIndexBuffer(5, buff5);
//   SetIndexBuffer(6, buff6);
//   SetIndexBuffer(7, buff7);
   IndicatorDigits(0);
   
   for (i = 0; i<NUM_BUFFERS; i++) {
      SetIndexStyle(i, DRAW_LINE, STYLE_SOLID, LINE_WIDTH /*, bufferColor[i]*/);
      SetIndexLabel(i, GetMarketHelperInfo(buffer2market[i], MARKET_NAME_IDX));
//      SetIndexEmptyValue(i, 0.0);
   }
   IndicatorShortName("Trading hours");
   return(0);
}
  
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit() {
   return(0);
}
 
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start() {
   int limit;   
   if (Period()>PERIOD_H1) {
      return(0);    // max.reasonable resolution is probably 1 hour
   }
   int countedBars = IndicatorCounted();
   if (countedBars < 0) return(-1);
   limit = Bars - countedBars - 1;
   for (int j = 0; j < NUM_BUFFERS; j++) {
     for (int i = limit; i >= 0; i--) {
        int val = EMPTY_VALUE; 
        if (IsMarketTime(buffer2market[j], Time[i])) {
          val = j+1;
        }
        switch (j) {
        case 0: buff0[i] = val; break;
        case 1: buff1[i] = val; break;
        case 2: buff2[i] = val; break;
        case 3: buff3[i] = val; break;
        case 4: buff4[i] = val; break;
        case 5: buff5[i] = val; break;
        case 6: buff6[i] = val; break;
        case 7: buff7[i] = val; break;
        }                  
     }      
   }
   
   return(0);
}

